class StateObj:
#
# init state methods
#
   def _init(self):
      print 'Init Default State'
   def initPatrol(self): 
      print 'Init Patrol State'
   def initFight(self):
      print  'Init Fight State'
   def initHide(self):
      print  'Init Hide State'
   def initHeal(self):
      print  'Init Heal State'
   def initEscape(self):
      print  'Init Escape State'
#
# jump state method
#
   def jump( self, newState = '_default' ):
      if self.initState.has_key(newState):   # if newState is defined
         self._state = newState             #   change state, and
         self.initState[self._state](self)  #   call proper init function
#
# touch methods
#
   def _touch(self, s):
      print 'I WAS TOUCHED BY ' + s
   def attack(self, s):
      print 'CHARGE TARGET ' + s
# 
# main touch method
#
   def touch( self, ob):
      if self.touchState.has_key(self._state):# if _state has defined method,
       self.touchState[self._state](self, ob)
      else:
       self.touchState['_default'](self, ob)
#
# instance class initialization
#
   def __init__(self):
      self._state = '_default'  # actual state attribute
   #
   # state method table 
   #
      self.initState = { 'patrol' : self.initPatrol, 
       'fight'  : self.initFight, 
       'hide'  : self.initHide, 
      'heal'  : self.initHeal, 
       'escape'  : self.initEscape, 
       '_default': self._init }
   #
   # touch method table
   #
   self.touchState = { 'patrol' : self.attack, 
     '_default': self._touch }          

#
# Sample code
#

x = StateObj()
x.touch('dragon')
x.jump('patrol')
x.touch('dragon')
